cls
@echo off
setlocal enabledelayedexpansion
color 0A
set waarschuwing=Lees a.u.b. eerst de handleiding bij dit script in c't 04/2015!

echo.
echo *****************************
echo *** Welkom bij c't-wimage ***
echo *****************************
echo.
echo %waarschuwing%
echo.
echo Dit script koppelt zoals in het artikel beschreven 
echo de boot- en de datapartitie van de usb-harddisk.
echo.

rem hulp nodig?
if /i "%1"=="/?" goto help
if /i "%1"=="-?" goto help
if /i "%1"=="/h" goto help
if /i "%1"=="-h" goto help
if /i "%1"=="--h" goto help
if /i "%1"=="/help" goto help
if /i "%1"=="-help" goto help
if /i "%1"=="--help" goto help

echo *** Enkele controles vooraf ... ***
echo.

set operation=*** Script vereist minstens Windows 8.1 ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentversion^"') do set version=%%a
if %version% lss 6.3 goto fout1

set operation=*** Dit script is alleen voor 32-bit-Windows ***
if exist "%ProgramFiles(x86)%" goto fout1

set operation=*** Script moet met administratorrechten draaien ***
whoami /groups | find "S-1-16-12288" > nul
if errorlevel 1 goto fout1

set operation=*** Datapartitie op actuele schijf bepalen ***
set usbdata=%~d0

set operation=*** Op de datapartitie moeten installatiebestanden staan ***
if not exist %usbdata%\sources goto fout1
if not exist %usbdata%\setup.exe goto fout1

set operation=*** Je hebt 32-bit-installatiebestanden nodig ***
dir /b %usbdata%\sources\sxs | find /i "amd64" > nul
if not errorlevel 1 goto fout1

set operation=*** Bootpartitie opvragen ***
rem Op welke partitie staat het actuele logische station?
set partition=
wmic LogicalDisk where (DeviceID="%usbdata%") assoc /assocclass:Win32_LogicalDiskToPartition > wmi.txt
if errorlevel 1 goto bootinvoer
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-28!"=="Win32_DiskPartition.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set partition=%%P
  )
)
if "%partition%"=="" goto bootinvoer
rem Op welke fysieke schijf staat deze partitie?
set drive=
wmic Partition where (DeviceID="%partition%") assoc /assocclass:Win32_DiskDriveToDiskPartition > wmi.txt
if errorlevel 1 goto bootinvoer
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-24!"=="Win32_DiskDrive.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set drive=%%P
  )
)
if "%drive%"=="" goto bootinvoer
rem Welke partities staan er nog meer op deze schijf?
set otherpart=
set bootpart=
wmic DiskDrive where (DeviceID="%drive%") assoc /assocclass:Win32_DiskDriveToDiskPartition > wmi.txt
if errorlevel 1 goto bootinvoer
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-28!"=="Win32_DiskPartition.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set otherpart=%%P
    if not "!otherpart!"=="%partition%" (
      if "!bootpart!"=="" (
        set bootpart=!otherpart!
      ) else (
        set bootpart=undefined
      )
    )
  )
)
if "%bootpart%"=="undefined" goto bootinvoer
if "%bootpart%"=="" goto bootinvoer
rem Welk logische station staat er op deze partitie?
set otherdisk=
set usbboot=
wmic Partition where (DeviceID="%bootpart%") assoc /assocclass:Win32_LogicalDiskToPartition > wmi.txt
if errorlevel 1 goto bootinvoer
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-26!"=="Win32_LogicalDisk.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set otherdisk=%%P
    if "!usbboot!"=="" (
      set usbboot=!otherdisk!
    ) else (
      set usbboot=undefined
    )
  )
)
if "%usbboot%"=="undefined" goto bootinvoer
if "%usbboot%"=="" goto bootinvoer
goto verder1

:bootinvoer
echo "Bootpartitie niet (of niet eenduidig) te bepalen."
set /p usbboot=Stationsletter van de partitie USB-Boot32:
if "%usbboot%"=="" goto fout2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

:verder1
echo.
echo Stationsletter van de partitie USB-boot32: %usbboot%
echo Stationsletter van de partitie USB-data32: %usbdata%
choice /m "Akkoord "
if not errorlevel 2 goto verder2

set /p usbboot=Stationsletter van de partitie USB-boot32:
if "%usbboot%"=="" goto fout2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

set /p usbdata=Stationsletter van de partitie USB-data32:
if "%usbboot%"=="" goto fout2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

:verder2
set operation=*** Op de gekozen partitie moet een bcd-store aanwezig zijn ***
if not exist %usbboot%\boot\bcd goto fout1
if not exist %usbboot%\efi\microsoft\boot\bcd goto fout1

set operation=*** De bootloader van het draaiende Windows mag niet gekozen worden ***
bcdedit /store %usbboot%\boot\bcd | find /i "{current}" >nul
if errorlevel 2 goto fout1
if %errorlevel% equ 0 goto fout1
bcdedit /store  %usbboot%\efi\microsoft\boot\bcd | find /i "{current}" >nul
if errorlevel 2 goto fout1
if %errorlevel% equ 0 goto fout1

set operation=*** De gekozen bootloader moet van een Windows PE/RE zijn ***
bcdedit /store %usbboot%\boot\bcd | find /i "ramdisk" >nul
if errorlevel 1 goto fout1
bcdedit /store  %usbboot%\efi\microsoft\boot\bcd | find /i "ramdisk" >nul
if errorlevel 1 goto fout1

set operation=*** Bootloader aanpassen ***
bcdedit /store %usbboot%\efi\microsoft\boot\bcd /set {default} device ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fout2
bcdedit /store %usbboot%\efi\microsoft\boot\bcd /set {default} osdevice ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fout2
bcdedit /store %usbboot%\boot\bcd /set {default} device ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fout2
bcdedit /store %usbboot%\boot\bcd /set {default} osdevice ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fout2

set operation=*** ei.cfg aanpassen ***
echo [EditionID] > %usbdata%\sources\ei.cfg
if errorlevel 1 goto fout2
echo. >> %usbdata%\sources\ei.cfg
echo [Channel] >> %usbdata%\sources\ei.cfg
echo OEM >> %usbdata%\sources\ei.cfg
echo. >> %usbdata%\sources\ei.cfg
echo [VL] >> %usbdata%\sources\ei.cfg
echo 0 >> %usbdata%\sources\ei.cfg
if errorlevel 1 goto fout2

echo Klaar!
pause
goto :eof

rem Voorwaarde niet vervuld
:fout1
set text=Aan de volgende voorwaarde is niet voldaan: 
goto foutuitvoer

rem Fout bij de uitvoering
:fout2
set text=Operatie mislukt:
goto foutuitvoer

:foutuitvoer
color 0C
echo.
echo %text%
echo.
echo %operation%
echo.
echo %waarschuwing%
echo.
pause
goto :eof


:help
echo.
echo %~nx0 leidt de bootloader op de partitie USB-Boot32 zo om, dat
echo hij setup.exe van de partitie USB-Data32 start
echo. 
echo %~nx0 moet met administratorrechten gestart worden!
echo.
echo %waarschuwing%
pause>nul
goto :eof
;
REM Samengesteld in 2014 door Axel Vahldiek en Hajo Schulz/c't
REM mailto: axv@ct.de