cls
@echo off
setlocal enabledelayedexpansion
color 0A

set waarschuwing=Lees a.u.b. eerst de handleiding bij dit script in c't 4/2015!

rem --------- Optioneel: aan de eigen omstandigheden aanpassen -----------

rem Dit script kan het laatst gemaakte image als systeemherstel-image opslaan 
rem Het wordt dan teruggezet, wanneer je in de Pc-instellingen
rem onder 'Bijwerken en herstellen'/'Systeemherstel' de optie 'Alles verwijderen en Windows
rem opnieuw installeren' kiest. Wanneer je dat wilt, verander je de waarde van de 
rem variabele 'Reset' van 0 in 1.

set Reset=0

rem Dit script kan het laatst gemaakte image als vernieuwings-image 
rem opslaan. Het wordt dan teruggezet, wanneer je in de Pc-instellingen
rem onder 'Bijwerken en herstellen'/'Systeemherstel' de optie 'Uw PC vernieuwen zonder
rem dat dit invloed heeft op uw bestanden' kiest. Wanneer je dat wilt, verander je de waarde 
rem van de variabele 'Refresh' van 0 in 1. Nota bene: er wordt dan een extra image gemaakt;  
rem het activeren van deze optie kost dus extra ruimte op het doelmedium!

set Refresh=0

rem Wanneer het script Windows na beindiging van de back-up moet afsluiten,
rem verander je de waarde van de variabele 'Shutdown' van 0 in 1.

set Shutdown=0

rem Pad naar de map voor het script zelf, vshadow.exe en
rem het reset-image zetten, bijvoorbeeld d:\resetimage\
rem Zonder verandering gebruikt het script de map, waarin het staat.
rem Geen spaties in het pad! Met afsluitende '\' !

set workdir=%~d0%~p0

rem ------------- Einde van de aanpassingen -----------

echo.
echo *********************************
echo *** Welkom bij c't-wimage ***
echo *****************************
echo.
echo %waarschuwing%
echo.

set description=
set operation=*** Commandline-argumenten controleren ***
:parseargs
if "%1"=="" goto endargs
rem hulp nodig?
if /i "%1"=="/?" goto help
if /i "%1"=="-?" goto help
if /i "%1"=="/h" goto help
if /i "%1"=="-h" goto help
if /i "%1"=="--h" goto help
if /i "%1"=="/help" goto help
if /i "%1"=="-help" goto help
if /i "%1"=="--help" goto help
rem Omschrijving van het image nodig?
set option=0
if /i "%1"=="/d" set option=1
if /i "%1"=="-d" set option=1
if %option%==1 (
  set description="%~2"
  shift /1
  shift /1
  goto parseargs
)
rem Image als herstel-image opslaan?
if /i "%1"=="/reset" set option=1
if /i "%1"=="-reset" set option=1
if %option%==1 (
  set Reset=1
  shift /1
  goto parseargs
)
rem Image als vernieuwings-image opslaan?
if /i "%1"=="/refresh" set option=1
if /i "%1"=="-refresh" set option=1
if %option%==1 (
  set Refresh=1
  shift /1
  goto parseargs
)
rem Systeem na de back-up afsluiten?
if /i "%1"=="/s" set option=1
if /i "%1"=="-s" set option=1
if /i "%1"=="/shutdown" set option=1
if /i "%1"=="-shutdown" set option=1
if %option%==1 (
  set Shutdown=1
  shift /1
  goto parseargs
)
color 0C
echo *** Onbekend commandline-argument: %1 ***
echo.
goto help
:endargs

echo *** Enkele controles vooraf ... ***
echo.

set operation=*** Script vereist Windows 8.1 ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentversion^"') do set version=%%a
if %version% lss 6.3 goto fout1

set operation=*** Dit script is alleen voor 32-bit-Windows ***
if exist "%ProgramFiles(x86)%" goto fout1

set operation=*** Script moet met administratorrechten draaien ***
whoami /groups | find "S-1-16-12288" > nul
if errorlevel 1 goto fout1

set operation=*** Werkdirectory mag niet op de Windows-schijf staan ***
if %~d0 equ %systemdrive% goto fout1

set operation=*** vshadow.exe moet in werkdirectory staan ***
set vshadow=vshadow32.exe
if not exist %workdir%%vshadow% goto fout1

set operation=*** In de werkdirectory moet een map 'Sources' staan ***
if not exist %workdir%sources goto fout1

set operation=*** Install.wim mag niet meer dan 1000 images bevatten ***
set action=append-image 
if not exist %workdir%sources\install.wim (
  set action=capture-image /compress:max
) else (
  set laatstenummer=1
  for /f "tokens=1,2* delims=: " %%L in ('%windir%\system32\dism /get-wiminfo /wimfile:%workdir%sources\install.wim') do (
    if "%%L"=="Index" set /a laatstenummer=%%M
  )
  if !laatstenummer! gtr 1000 goto fout1
)

echo *** Geen problemen gevonden, we kunnen beginnen ***
echo.

echo *** Voorbereidingen ... ***
set operation=*** RunOnce-key toevoegen om WinRE terug te zetten na herstelling ***
reg add HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /f /v "enablewinre" /d "reagentc /enable" >nul 2>nul
if errorlevel 1 goto fout2

set operation=*** Windows RE naar Windows-partitie verplaatsen ***
reagentc /disable >nul 2>nul
if errorlevel 1 goto fout2

set operation=*** Vrije stationsletter voor schaduwkopie zoeken ***
echo.
echo %operation%
for %%l in (P Q R S T U V W X Y Z D E F G H I J K L M N O) do (  
  set sklw=%%l
  mountvol %%l: /L >nul
  if errorlevel 1 (
    subst | findstr /B "%%l:" >nul
    if errorlevel 1 (
      net use %%l: >nul 2>&1
      if errorlevel 1 goto verder
    )
  )
)
goto fout2
:verder
echo gebruikt %sklw%:

echo.
set operation=*** Schaduwkopie van de Windows-partitie maken ***
echo.
echo %operation%
%workdir%%vshadow% -p -script=%workdir%vshadowtemp.cmd %systemdrive% >nul 2>nul
if errorlevel 1 goto fout2
call %workdir%vshadowtemp.cmd >nul 2>nul
if errorlevel 1 goto fout2
%workdir%%vshadow% -el=%SHADOW_ID_1%,%sklw%:
if errorlevel 1 goto fout2

echo.
echo.
set operation=*** Image herstellen/aankoppelen ***
echo %operation%
echo.
echo Het kan erg lang duren voordat het voortgangsbalkje verschijnt.
echo Na het bereiken van 100 procent kan er weer tijd overheen gaan, 
echo voordat het proces verder gaat.
echo. 
if %description%.==. set description="%date:~9,4%-%date:~6,2%-%date:~3,2%-%time%-%computername%"
%windir%\system32\dism /%action% /imagefile:%workdir%sources\install.wim /capturedir:%sklw%: /name:"%date:~9,4%-%date:~6,2%-%date:~3,2%-%time%-%computername%" /description:%description% /checkintegrity /verify /scratchdir:%workdir%
if errorlevel 1 goto fout2

echo.
set operation=*** Schaduwkopie weer verwijderen ***
echo. 
echo %operation%
%workdir%%vshadow% -ds=%SHADOW_ID_1%
if errorlevel 1 goto fout2

set operation=*** Windows met het nieuwe image bekendmaken ***
if not "%reset%" equ "1" goto next1
echo.
echo.
echo %operation%
set lastindex=0
for /f "tokens=*" %%L in ('%windir%\system32\dism /get-wiminfo /wimfile:%workdir%sources\install.wim ^| find "Index"') do (
  set counter=%%L
  set lastindex=!counter:~8,-1!
)
if %lastindex% equ 0 goto fout2
reagentc /setosimage /path %workdir%sources\install.wim /index %lastindex%
if errorlevel 1 goto fout2
:next1

echo.
echo *** Opruimen ***
set operation=*** Windows RE weer op zijn oude plek terugzetten ***
reagentc /enable >nul 2>nul
if errorlevel 1 goto fout2

set operation=*** RunOnce-key weer verwijderen ***
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /v "enablewinre" /f >nul 2>nul
if errorlevel 1 goto fout2

set operation=*** En nu toch het refresh-image maken ***
if not "%refresh%" equ "1" goto next2
echo. 
echo.
echo %operation%
recimg /createimage %workdir%sources
if errorlevel 1 goto fout2
:next2

echo.
echo.
echo *** Klaar! ***
if "%shutdown%" equ "1" shutdown -s -t 0
pause
goto :eof

rem Aan voorwaarde is niet voldaan
:fout1
set text=Aan de volgende voorwaarde werd niet voldaan: 
goto foutuitvoer

rem Fout bij de afhandeling
:fout2
set text=Operatie mislukt:
goto foutuitvoer

:foutuitvoer
color 0C
echo.
echo %text%
echo.
echo %operation%
echo.
echo %waarschuwing%
echo.
echo Ruim achter mezelf op...
reagentc /enable >nul 2>nul
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /v "enablewinre" /f >nul 2>nul
%workdir%%vshadow% -ds=%SHADOW_ID_1% >nul 2>nul
echo Opruimen klaar.
pause
goto :eof

rem Afgebroken door gebruiker
:afgebroken
echo Afgebroken door gebruiker
pause
goto :eof

:help
echo.
echo %~nx0 breidt het bestand install.wim uit met een volgend image. 
echo Ontbreekt het bestand, dan wordt er een nieuw aangemaakt.
echo.
echo %~nx0 begrijpt de volgende commandline-argumenten:
echo   /Reset            - het nieuwe image als herstel-image opslaan
echo   /Refresh          - het nieuwe image als vernieuwings-image opslaan
echo   /S                - Windows na voltooien van de back-up afsluiten
echo   /Shutdown         - Windows na voltooien van de back-up afsluiten
echo   /D "Omschrijving" - "Omschrijving" als omschrijving van het image opslaan
echo.
echo %~nx0 moet met administratorrechten gestart worden!
echo.
echo %waarschuwing%
echo.
pause
goto :eof
;
REM Samengesteld in 2014 door Axel Vahldiek/c't
REM mailto: axv@ct.de